/*
	Copyright (C) 2005  Michael C. Shultz

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions
	are met:

	1. Redistributions of source code must retain the above copyright
	   notice, this list of conditions and the following disclaimer.
	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
	IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
	OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
	IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
	INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
	NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
	DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
	THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
	THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

	Michael C. Shultz
	ringworm01@gmail.com
	Box 3238 Landers, CA 92285
*/

#include	<libMGPM.h>
/***********************************************************************/
/* awk script - used to parse pm-020.conf                              */
/***********************************************************************/
/*
#!/bin/sh

HELP="usage: dbConfigure.sh %%PREFIX%%/etc/portmanager/pm-020.conf %%PREFIX%%/share/portmanager/configure.db"
if test $1
then
	if test $2
	then
	
echo "keyzzNULLzzvaluezzNULLzz" > $2;awk 'BEGIN{ FS = "|" } NF == 3 && $1 !~ /#/  && $1 !~ /CATEGORY\/PORT/ && $2 !~ /#/ {print $1 "zzNULLzz" $2 "zzNULLzz"}' $1 >> $2

	else
		echo $HELP
	fi
else
	echo $HELP
fi
*/
/***********************************************************************/
int	MGPMrReadConfigure( structProperty* property )
{
	FILE*	configDbStream		= NULL;	
	char*	configFileNameOld	= NULL;
/*	char	id[]			= "MGPMrReadConfigure";	*/
	char*	buffer			= NULL;
	char*	command			= NULL;
	char*	nullBase		= NULL;
	int	bufferIdx		= 0;
	int	configDbFileSize	= 0;

	configFileNameOld	= ( char* )calloc( 255, 1 );
	command			= ( char* )calloc( 0xffff, 1 );
	/*************************************/
	/* update old conf file if it exists */
	/*************************************/
	strcpy( configFileNameOld, ETCDIR);
	strcat( configFileNameOld, "/portmanager.conf" ); 
	if( MGrIfFileExist( configFileNameOld ) )
	{
		strcpy( command, "mv " );
		strcat( command, configFileNameOld );
		strcat( command, " " );
		strcat( command, configFileNameOld );
		strcat( command, "_OLD" );
		fprintf( stdout, "moving %s to %s%s\n", configFileNameOld, configFileNameOld, "_OLD" );
		fprintf( stdout, "portmanager configuration file is now called %s. Please review %s%s and %s and make any nessesary changes.\n",
			property->configConfFileName, property->configConfFileName, ".SAMPLE", configFileNameOld);
		while( fflush( stdout ) );
		system( command );		
	}

	/***************************************************************************/
	/* if pm-020.conf missing then copy pm-020.conf.SAMPLE to pm-020.conf */
	/***************************************************************************/
	if( MGrIfFileExist( property->configConfFileName ) == 0 )
	{
		strcpy( command, "cp " );
		strcat( command, property->configConfFileName );
		strcat( command, ".SAMPLE " );
		strcat( command, property->configConfFileName );
		system( command );
	}
	strcpy( command, "chmod 0600 " );
	strcat( command, property->configConfFileName );
	system( command );

	strcpy( command, "chmod 0600 " );
	strcat( command, property->configConfFileName );
	strcat( command, ".SAMPLE " );
	system( command );

	strcpy( command, "chown root:wheel " );
	strcat( command, property->configConfFileName );
	system( command );

	strcpy( command, "chown root:wheel " );
	strcat( command, property->configConfFileName );
	strcat( command, ".SAMPLE " );
	system( command );

	/*********************/
	/* parse pm-020.conf */
	/*********************/
	strcpy( command, "echo \"" );
	strcat( command, property->fieldConfigDbKey );
	strcat( command, "zzNULLzz" );
	strcat( command, property->fieldConfigDbValue );	
	strcat( command, "zzNULLzz\" > " );
	strcat( command, property->configDbFileName );
	strcat( command, ";awk 'BEGIN{ FS = \"|\" } NF == 3 && $1 !~ /#/  && $1 !~ /CATEGORY\\/PORT/ && $2 !~ /#/ {print \"/\" $1 \"zzNULLzz\" $2 \"zzNULLzz\"}' " );
	strcat( command, property->configConfFileName );
	strcat( command, " >> " );
	strcat( command, property->configDbFileName );
	system( command );
	configDbFileSize	= MGrFileSize(  property->configDbFileName );
	buffer			= malloc( configDbFileSize + 1 );
	configDbStream		= fopen( property->configDbFileName, "r" );
	fread( buffer, configDbFileSize, 1, configDbStream ); 
	buffer[configDbFileSize]	= 0;	/* so buffer may be treated as a string */
	fclose( configDbStream );
	/* convert zzNULLzz to NULLs */
	while( strstr( buffer + bufferIdx,  "zzNULLzz" ) )
	{
		nullBase	= strstr( buffer + bufferIdx,  "zzNULLzz" );
		nullBase[0]	= 0;
		nullBase[1]	= 0;

		memcpy( (char*)nullBase+1, (char*)nullBase+8, strlen(nullBase+8) + 1  );
/*
		strcat( nullBase+1, nullBase+8 );
*/
		bufferIdx	= (nullBase+1) - buffer;
		configDbFileSize	-= 7;
	}
	configDbStream	= fopen( property->configDbFileName, "w" );
	fwrite( buffer, configDbFileSize, 1, configDbStream );

	fclose( configDbStream );
	free( configFileNameOld );
	free(buffer);
	free(command);
	return( 0 );
}
